package com.zhongshu.card.server.core.dao.devices.impl;

import com.github.microservice.components.data.mongo.mongo.helper.DBHelper;
import com.zhongshu.card.client.model.devices.deviceProduct.DeviceProductSearch;
import com.zhongshu.card.server.core.dao.BaseImpl;
import com.zhongshu.card.server.core.dao.devices.extend.DeviceProductDaoExtend;
import com.zhongshu.card.server.core.domain.devices.DeviceProduct;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

/**
 * @Author TRX
 * @CreateDate: 2023/4/12
 * @Version: 1.0
 */
public class DeviceProductDaoImpl extends BaseImpl implements DeviceProductDaoExtend {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Autowired
    private DBHelper dbHelper;

    @Override
    public Page<DeviceProduct> page(Pageable pageable, DeviceProductSearch param) {
        Criteria criteria = buildFilterCriteria(param);

        Sort sort = buildSort(param);
        Query query = Query.query(criteria);
        query.with(sort);
        return dbHelper.pages(query, pageable, DeviceProduct.class);
    }

    public Criteria buildFilterCriteria(DeviceProductSearch param) {
        param.setOid("");
        Criteria criteria = buildCriteria(param);

        // 项目oid
        if (StringUtils.isNotEmpty(param.getProjectOid())) {
            criteria.and("projectOid").is(param.getProjectOid());
        }

        if (StringUtils.isNotEmpty(param.getBeLongOid())) {
            criteria.and("beLongOid").is(param.getBeLongOid());
        }

        if (param.getTransaction() != null) {
            criteria.and("transaction").is(param.getTransaction());
        }

        if (param.getMultipleOrders() != null) {
            criteria.and("multipleOrders").is(param.getMultipleOrders());
        }

        // 模糊搜索
        List<Criteria> criterias = new ArrayList<>();

        if (StringUtils.isNotEmpty(param.getName())) {
            Pattern pattern = Pattern.compile("^.*" + param.getName() + ".*$");
            criterias.add(Criteria.where("name").is(pattern));
        }

        if (StringUtils.isNotEmpty(param.getCode())) {
            Pattern pattern = Pattern.compile("^.*" + param.getCode() + ".*$");
            criterias.add(Criteria.where("code").is(pattern));
        }

        if (!CollectionUtils.isEmpty(criterias)) {
            criteria.andOperator(criterias.toArray(new Criteria[]{}));
        }
        return criteria;
    }

}
